/**
 * Created by sghachem on 08/06/2017.
 */
(function () {
    'use strict';

    angular
        .module('app')
        .controller('ReleveplusController', ReleveplusController);

    function ReleveplusController($scope, $rootScope, NgMap, jsonsexp,jsontpa, $window, $timeout, PlanService, APTService, ArboService, FlashModalService) {
        var vm = this;
        $rootScope.pointsTable = [];
        vm.releveplus = releveplus;

        function releveplus() {
            vm.dataLoading = true;

        }
        $scope.PlanDimensionHeight = function(n){
            return new Array(n);
        };
        $scope.PlanDimensionWidth=function(n){
            return new Array(n);
        };

        // ***************************************************** Aside **************************************************//
        $scope.showSelected = function (CurrentZone){
            console.log(CurrentZone);
            vm.current_analyses_point = CurrentZone;
            // Mocking Plan zone
            $scope.CurrentImage = "/app-content/img/Mairie_rdc-Presentation3_4.jpg";
            // Get the plan image
            PlanService.GetImageByID(CurrentZone.resourceName).then(function (data) {
                // Succes get plan
                // $scope.CurrentImage = data.data.plan.imageView;
                console.log('Plan : ', data.data.data.plan.imageView.path)
                    },
                    function () {
                        console.log('error, Get plan Failed :( !')
                    });
            $window.scrollTo(0, 200);
            var element = angular.element('.fiche_holder');
            element.addClass('slideUp');
            var chev = angular.element('.togglechevron');
            if(!chev.hasClass('fa-chevron-down')) {
                chev.toggleClass('fa-chevron-down')
            }
        };
        $scope.showMap =function () {
            var element = angular.element('.fiche_holder');
            element.toggleClass('slideUp');
            angular.element('.togglechevron').toggleClass('fa-chevron-up');
            angular.element('.togglechevron').toggleClass('fa-chevron-down');
        };


        $scope.treeOptions = {
            nodeChildren: "children",
            dirSelectable: true,
            injectClasses: {
                ul: "a1",
                li: "a2",
                liSelected: "a7",
                iExpanded: "a3",
                iCollapsed: "a4",
                iLeaf: "a5",
                label: "a6",
                labelSelected: "a8"
            }
        }

        $scope.zones = jsonsexp;
        //***************************************************** GET analaysis point types **************************************************//

        APTService.GetAPT().then(function (res) {
            $scope.listAPT = res.data.data.analysisPointTypeList;
            console.log($scope.listAPT)
        },
        function () {
            console.log('error, types point d analyses')
        });


        $scope.SetAPT = function () {
            for (var i = 0; i < jsontpa.length; i++){
                (function(){
                var data = {};
                data.name = jsontpa[i].name;
                console.log(data.name);
                var parent = jsontpa[i].children ;
                APTService.CreateAPT(data).then(function (data) {
                     var id = data.data.data.analysisPointType.resourceName ;
                         for (var key in parent){
                             var obj = {};
                             var k = parent[key];
                             obj.name = k.name;
                             obj.parentResourceName = id;
                             APTService.CreateAPT(obj).then(function (res) {
                                 console.log(res)
                                 },
                                 function () {
                                     console.log('error, children')
                                 });
                         }
                     },
                     function () {
                         console.log('error, parent !')
                     });
                })();
            }
        };
        //***************************************************** Container **************************************************//
                //**********************************
                //                  Map ***********************//

        // List points
        vm.points = [
            {id:'1', name: 'Project 1', position:[48.9123375,2.3143955]},
            {id:'2', name: 'Project 2', position:[48.9223375,2.3243955]},
            {id:'3', name: 'Project 3', position:[48.91112821450604,2.333770701661706]},
            {id:'4', name: 'Project 4', position:[48.91512821450604,2.343790701661706]},
            {id:'5', name: 'Project 5', position:[49.748887,2.900391]},
            {id:'6', name: 'Project 6', position:[49.248887,1.500391]},
            {id:'7', name: 'Project 7', position:[49.648887,2.600391]},
            {id:'8', name: 'Project 8', position:[42.648887,2.400391]},
            {id:'9', name: 'Project 9', position:[45.648887,2.600391]},
            {id:'10', name: 'Project 10', position:[44.648887,2.200391]},
        ];

        NgMap.getMap().then(function (map) {
            $scope.map = map;
            $scope.initMarkerClusterer();
            console.log($scope.initMarkerClusterer());
        });
        $scope.splite =function () {
            angular.element('.slipted_holder').toggleClass('open');
            angular.element('.splite').toggleClass('fa-angle-right');
            google.maps.event.trigger($scope.map, 'resize')
        }
        $scope.$on('mapInitialized', function(evt, evtMap) {
            $scope.map.push(evtMap);
        });



        $scope.initMarkerClusterer = function () {
            var markers = vm.points.map(function (point) {
                return $scope.createMarkerForPoint(point);
            });
            var mcOptions = {
                styles:[{
                    url: "https://googlemaps.github.io/js-marker-clusterer/images/m1.png",
                    width: 60,
                    height:60,
                    fontFamily:"comic sans ms",
                    textSize:15,
                    textColor:"#fff",
                    backgroundSize : "contain",
                    backgroundPosition: "center"
                }]
            };
            return new MarkerClusterer($scope.map, markers, mcOptions);
        };


        $scope.createMarkerForPoint = function (point) {
            var marker = new google.maps.Marker({
                position: new google.maps.LatLng(point.position[0], point.position[1]),
                title: point.name
            });
            google.maps.event.addListener(marker, 'click', function () {
                $scope.selectedPoint = point;
                $scope.map.showInfoWindow('myInfoWindow', this);
            });
            return marker;
        };

        function GetCenter() {
            var lat = 0, long = 0;
            for (var key in vm.points){
                lat = lat + vm.points[key].position[0];
                long = long + vm.points[key].position[1];
            }
            $scope.x = lat/(vm.points.length)
            $scope.y = long/(vm.points.length)
            $scope.zoomMap = 6;
        }
        $timeout(function () {
            $scope.zoomMap = 14;
            $scope.x = 48.9123375;
            $scope.y =2.3143955;
        },2000)
        GetCenter();

        //**********************************
        //                End Map ***********************//

        $rootScope.modal_selected_zone_detail = false;
        // Modal file Point 
        $scope.openPointFile = function (selectedZone) {
            $rootScope.modal_selected_zone_detail = true;
        }

        // Open Modal add plan
        $rootScope.addplaModal = false;

        // Open Modal add Point
        $rootScope.addpoint = false;
        $rootScope.list_points_modal = false;
        vm.formidpa = '';
        vm.addPoint = function (name,id) {
            vm.formidpa = id;
            $rootScope.addpointModal = true;
            $rootScope.PointNameToAdd = name;
        }
        vm.listALlPoiints = function () {
            $rootScope.list_points_modal = true;
        }


        $scope.PlanPoints =  [
            {"posX":527.421875,"posY":306,
                "width":35,"height":35,
                "className":"marker_red_select",
                "relatedpoint":"1",
                "marker_id":"elementmarker1",
                "rotate_deg":-45,
                "scale":1
            },
            {"posX":327.421875,"posY":106,
                "width":35,"height":35,
                "className":"marker_black_select",
                "relatedpoint":"2",
                "marker_id":"elementmarker2",
                "rotate_deg":0,
                "scale":1},
            {"posX":427.421875,"posY":206,
                "width":35,"height":35,
                "className":"marker_orange_select",
                "relatedpoint":"1",
                "marker_id":"elementmarker3",
                "rotate_deg":0,
                "scale":1}
            ,
            {"posX":227.422,"posY":389,
                "width":35,"height":35,
                "className":"marker_green_select",
                "relatedpoint":"2",
                "marker_id":"elementmarker4",
                "rotate_deg":0,
                "scale":1}
        ];

        //**********************************
        //                Load All zones ***********************//
        function GetAllArbo() {
            var Zones = [];
            ArboService.GetClients().then(function (res) {
                var response = res.data.data.clientList;
                    _.forOwn(response, function(value, key) {
                        Zones[key] = {};
                        Zones[key].label = response[key].businessName;
                        Zones[key].resourceName = response[key].resourceName;

                        ArboService.GetZones().then(function (data) {
                            Zones[key].children = data.data.data.zoneList;
                                $scope.zones = Zones;
                            },
                            function () {
                                FlashModalService.Error('Un erreur est survenue lors de chargement des zones');
                                console.log('error, Get zones')
                            });
                    } );
                },
            function (res) {
                console.log('error Get Clients')
            });
            /**/
        };
        GetAllArbo();

        //**********************************
        //                End Load All zones ***********************//

        //**********************************
        //                Set All zones ***********************//

        $scope.loadAllZones = function () {
            // Get zones types
            ArboService.GetZonesTypes().then(function (res) {
                var zoneTypes = res.data.data.zoneTypeList;
                    console.log(zoneTypes)
                    var index = _.findIndex(zoneTypes, {label: 'Zone Diagnotic GeoLoc'});
                    var index2 = _.findIndex(zoneTypes, {label: 'Zone Diagnotic'});
                    var index3 = _.findIndex(zoneTypes, {label: 'Zone Standard'});
                    var ZTypeDG = zoneTypes[index].resourceName;
                    var ZTypeD = zoneTypes[index2].resourceName;
                    var ZTypeDS = zoneTypes[index3].resourceName;
                // Set Clients

                        console.log(jsonsexp[0]);
                        var data = {};
                        var json = jsonsexp[0];

                                var clientResourceName = 'API_ARBO_CLIENT_91201eb64ee664f';
                                var dataChild = {},
                                    childrens = jsonsexp[0].children;
                                // Set  zones
                            console.log('childrens', childrens);
                                for (var j in childrens){
                                            dataChild.label = childrens[j].name;
                                            //console.log(childrens[j].name);
                                            dataChild.isGeoLoc = 0;
                                            dataChild.zoneTypeResourceName = ZTypeDS;
                                            dataChild.clientResourceName = clientResourceName;
                                            var subChildrens = childrens[j].children;
                                            ArboService.SetZone(dataChild).then(function (resp) {
                                                var parentResourceName = resp.data.data.zone.resourceName;
                                                // set sub children
                                                console.log('subChildrens.length', subChildrens.length);
                                                for (var i in subChildrens){
                                                    console.log('i: '+ i);
                                                            var dataSubChildren = {};
                                                            dataSubChildren.label = subChildrens[i].name;
                                                            console.log('subChildren.label', dataSubChildren.label);
                                                            dataSubChildren.isGeoLoc = 1;
                                                            dataSubChildren.zoneTypeResourceName = ZTypeDG;
                                                            dataSubChildren.geoLocInfos = JSON.stringify(subChildrens[i].geoloc);
                                                            dataSubChildren.clientResourceName = clientResourceName;
                                                            dataSubChildren.parentResourceName = parentResourceName;

                                                            var LastSubChild = subChildrens[i].children;
                                                            ArboService.SetZone(dataSubChildren).then(function (e) {
                                                                    var SubparentResourceName = e.data.data.zone.resourceName;
                                                                    for(var x  in LastSubChild){

                                                                                var LastdataSubCHildre = {};
                                                                                LastdataSubCHildre.label = LastSubChild[x].name;
                                                                                console.log(LastSubChild[x].name);
                                                                                LastdataSubCHildre.isGeoLoc = 0;
                                                                                LastdataSubCHildre.zoneTypeResourceName = ZTypeD;
                                                                                LastdataSubCHildre.clientResourceName = clientResourceName;
                                                                                LastdataSubCHildre.parentResourceName = SubparentResourceName;
                                                                                ArboService.SetZone(LastdataSubCHildre).then(function (ex) {
                                                                                    },
                                                                                    function (ex) {
                                                                                        console.log('error last')
                                                                                    })

                                                                    }
                                                                    console.log('success one');
                                                                },
                                                                function () {
                                                                    console.log('error, sub zone')
                                                                })
                                                }
                                            }, function (resp) {
                                                console.log('error, parent zone')
                                            })
                                }


                    // End Set Clients
                },
            function (res) {
                console.log('error get zones types !')
            })
            // End Get zones types



            // Set Zones
            /*for (var key in jsonsexp){
                (function(){
                    var data = {};
                    data.businessName = jsonsexp[key].name;
                    ArboService.SetClient(data).then(function (res) {
                        console.log(res);
                        var dataChild = {},
                            childrens = jsonsexp[key].children;

                            dataChild.parentResourceName = res.data.data.zoneType.resourceName;
                            for (var j in childrens){
                                dataChild.name = childrens[j].name;
                            }

                    },
                    function () {
                        console.log('error, parent !')
                    });
                })();
            }*/
            // End Set Zones
        }
        //**********************************
        //                End Set All zones ***********************//
    }

})();
